import test from '../setup';
import { promisify, compressImage, loadImage } from '../../src';
import fs from 'fs';
import path from 'path';
import mkdirp from 'mkdirp';

var TEST_DIR = path.join(__dirname, '..', 'data');
var TEST_FILE = path.join(TEST_DIR, 'test.png');

var IMAGE = {
  width: 2,
  height: 3,
  data: new Uint8Array([255, 0, 0, 255, 0, 255, 255, 255, 0, 0, 255, 255, 255, 255, 0, 255, 0, 255, 0, 255, 255, 0, 255, 255])
};

// Test that we can write and read an image, and that result is identical
test('io#write-read-image', async function (t) {
  await promisify(mkdirp)(TEST_DIR);
  var file = fs.createWriteStream(TEST_FILE);
  file.on('close', async function () {
    var result = await loadImage(TEST_FILE);
    t.same(result, IMAGE);
    t.end();
  });
  compressImage(IMAGE).pipe(file);
});
//# sourceMappingURL=write-read-image.js.map